#include <bits/stdc++.h>

using namespace std;

void dfs(int v, vector<int> &ohr, int h, vector<vector<int>> &a, int pr) {
    if (h == 0) {
        return;
    }
    ohr[v] = h;
    for (int i = 0; i < a[v].size(); ++i) {
        if (a[v][i] != pr && ohr[a[v][i]] < h - 1) {
            dfs(a[v][i], ohr, h - 1, a, v);
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> a(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        a[x].push_back(y);
        a[y].push_back(x);
    }
    vector<int> ohr(n);
    vector<pair<int, int>> zp(k);
    for (int i = 0; i < k; ++i) {
        int p, h;
        cin >> p >> h;
        p--;
        zp.emplace_back(h, p);
    }
    sort(zp.rbegin(), zp.rend());
    for (int i = 0; i < k; ++i) {
        if (ohr[zp[i].second] - 1 < zp[i].first) {
            dfs(zp[i].second, ohr, zp[i].first + 1, a, -1);
        }
    }

    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if (ohr[i] > 0) {
            ans.push_back(i);
        }
    }
    sort(a.begin(), a.end());
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i] + 1 << " ";
    }
}